<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class PindahsubinvModel extends BaseModel
{
	/**
	 * table name from database
	 */
	protected $table = "pindahbarangsubinv";

	/**
	 *   alias table for relation issues
	 */
	protected $aliasTable = "pindahsubinv";

	/**
	 * primary key from table remember eloquent doesnt support composite primary key
	 */
	protected $primaryKey = "id";
	/**
	 * check the incrementing boolean if the incrementing from database is false then the value is false by default
	 */
	// public $incrementing = false;
	/**
	 * fillable property for eloquent attribute cast
	 */
	protected $fillable = [
		"id", "moNumber", "kapalId", "type", "requesterId", "approverId", "fromLocationId", "toLocationId", "transactionType",
		"dateRequired", "quantity", "status", "dateCreated", "komentar", "date_updated", "feedback", "tglApproved"
	];
	/**
	 * Creating raw object from table that, this purpose for making you easier for remembering all attribute
	 */


	/**
	 * paging for default paging purpose
	 * if you want to add new paging property you have to add the property in this array
	 * you have to add the relation value
	 * remember this is not suported casting value you have to handle by your self
	 */
	protected $aliasPaging = [
		"id" 				=> "pindahsubinv.id",
		"moNumber" 			=> "pindahsubinv.moNumber",
		"fromLocationId" 	=> "pindahsubinv.fromLocationId",
		"fromLocationName" 	=> "fromLocationId.namaLokasi",
		"toLocationId" 		=> "pindahsubinv.toLocationId",
		"toLocationName" 	=> "toLocationId.namaLokasi",
		"transactionType"	=> "pindahsubinv.transactionType",
		"dateRequired" 		=> "pindahsubinv.dateRequired",
		"type" 				=> "pindahsubinv.type"
	];

	/**
	 * relation from ' . lokasiitem . ' by ' . fromLocationId 
	 * join lokasiitem on lokasiitem.id = pindahsubinv.fromLocationId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationFromLocationId($alias = "fromLocationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "pindahsubinv.fromLocationId");
		return $this;
	}
	/**
	 * relation from ' . lokasiitem . ' by ' . toLocationId 
	 * join lokasiitem on lokasiitem.id = pindahsubinv.toLocationId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationToLocationId($alias = "toLocationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "pindahsubinv.toLocationId");
		return $this;
	}
	/**
	 * relation from ' . users . ' by ' . approverId 
	 * join users on users.id = pindahsubinv.approverId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationApproverId($alias = "approverId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "pindahsubinv.approverId");
		return $this;
	}
	/**
	 * relation from ' . users . ' by ' . requesterId 
	 * join users on users.id = pindahsubinv.requesterId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationRequesterId($alias = "requesterId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "pindahsubinv.requesterId");
		return $this;
	}


	public function joinRelationKapalId($alias = "kapalId")
	{
		$this->getQuery()->leftjoin("kapal as $alias", "$alias.id", "=", "pindahsubinv.kapalId");
		return $this;
	}
	/* 
	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", "$alias.voyageKode", "=", "pindahsubinv.voyageKode");
		return $this;
	} */
}
